unit mnozidva;
(*******************************)


interface
(*******************************)

uses mnozijed;

procedure prienik(var mp:zoznam; m1:zoznam; m2:zoznam);
procedure zjednotenie(var mz:zoznam; m1:zoznam; m2:zoznam);
procedure vypis(m:zoznam);

implementation
(*******************************)

procedure prienik(var mp:zoznam; m1:zoznam; m2:zoznam);
var p : char;
    c1, c2, c, n : smernik;
    jevoboch, uzjetam : boolean;
begin
  c1:=m1.zaciatok; 
  while c1<>nil do begin
    p:=c1^.hodnota; c2:=m2.zaciatok; jevoboch:=false;
    while c2<>nil do begin
      if c2^.hodnota=p then jevoboch:=true; (* mal by som vyskocit *)
      (* if jevoboch then exit; ja chcem break *)
      c2:=c2^.sused;
    end;
    if jevoboch then begin
      c:=mp.zaciatok; uzjetam:=false;
      while c<>nil do begin
        if c^.hodnota=p then uzjetam:=true;
        (* if uzjetam then exit; ja chcem break *)   
        c:=c^.sused;
      end;
      if not uzjetam then begin (* a mame ho prienikara jedneho *)
        new(n);
        n^.hodnota:=p;
        n^.sused:=mp.zaciatok;
        mp.zaciatok:=n;
      end;
    end;
    c1:=c1^.sused;
  end;
end;

procedure zjednotenie(var mz:zoznam; m1:zoznam; m2:zoznam);
var p : char;
    c, n : smernik;
    c12 : array[1..2] of smernik;
    i : longint;
    uzjetam : boolean;
begin
  c12[1]:=m1.zaciatok; c12[2]:=m2.zaciatok;
  for i:=2 downto 1 do begin
    while c12[i]<>nil do begin
      p:=c12[i]^.hodnota; c:=mz.zaciatok; uzjetam:=false;
      while c<>nil do begin
        if c^.hodnota=p then uzjetam:=true;
        (* if uzjetam then exit; ja chcem break *)
        c:=c^.sused;
      end;
      if not uzjetam then begin (* a mame ho *)
        new(n);
        n^.hodnota:=p;
        n^.sused:=mz.zaciatok;
        mz.zaciatok:=n;
      end;
      c12[i]:=c12[i]^.sused;
    end;
  end; 
end;

procedure vypis(m:zoznam);
var clen : smernik;
begin
  clen:=m.zaciatok;
  while clen<>nil do begin
    write(clen^.hodnota);
    clen:=clen^.sused;
  end;
  writeln;
end;


begin
(*******************************)

end.