unit mnozijed;
(*******************************)

interface
(*******************************)

type smernik = ^struct;
     struct  =  record
                  hodnota : char;
                  sused   : smernik;
                end;

     zoznam  =  record
                  zaciatok : smernik;
                  koniec   : smernik;
                end;

var f1, f2 : text;

function otvaraj(s1:string; s2:string) : boolean;
procedure popchaj(var m1:zoznam; var m2:zoznam);


implementation
(*******************************)

(* pootvara subory na citanie *)
function otvaraj(s1:string; s2:string) : boolean;
begin
  otvaraj:=true;
  {$I-}
    assign(f1, s1); reset(f1); if ioresult<>0 then otvaraj:=false;
    assign(f2, s2); reset(f2); if ioresult<>0 then otvaraj:=false;
  {$I+}
end;

(* pchame na zaciatok po znakoch *)
procedure popchaj(var m1:zoznam; var m2:zoznam);
var novy : smernik;
    znak : char;
begin
  m1.zaciatok:=nil; m1.koniec:=nil;
  m2.zaciatok:=nil; m2.koniec:=nil;
  while not eof(f1) do begin
    read(f1, znak);
    new(novy);
    novy^.hodnota:=znak;
    novy^.sused:=m1.zaciatok;
    m1.zaciatok:=novy;
  end;
  close(f1);
  while not eof(f2) do begin
    read(f2, znak);
    new(novy);
    novy^.hodnota:=znak;
    novy^.sused:=m2.zaciatok;
    m2.zaciatok:=novy;
  end;
  close(f2);
end;


begin
(*******************************)

end.